import java.util.ArrayList;
import java.util.LinkedList;
import java.util.concurrent.TimeUnit;

class Main {

    /**
     * The main() function
     * @param String[] args main() function arguments array
     */
    public static void main(String[] args) {
        ListExtension<Integer> array = new ListExtension<Integer>(new ArrayList<Integer>());
        ListExtension<Integer> list = new ListExtension<Integer>(new LinkedList<Integer>());

        for (int i = 0; i < 1000000; i++) {
            array.add(i);
            list.add(i);
        }

        long startTime = System.nanoTime();
        // for (int i = 0; i < 100000; i++) {
        //    array.addIter(array.size() / 2, i);
        // }
        array.addNelements(array.size() / 2, 100000);
        long stopTime = System.nanoTime();
        long execTimeArray = stopTime - startTime;
        //System.out.println("Insert time in the middle of the ArrayList: " + TimeUnit.NANOSECONDS.toSeconds(execTime) + " s");
        System.out.println("Insert time in the middle of the ArrayList: " + execTimeArray + " ns");

        startTime = System.nanoTime();
        // for (int i = 0; i < 100000; i++) {
        //     list.addIter(list.size() / 2, i);
        // }
        list.addNelements(list.size() / 2, 100000);
        stopTime = System.nanoTime();
        long execTimeLinked = stopTime - startTime;
        //System.out.println("Insert time in the middle of the LinkedList: " + TimeUnit.NANOSECONDS.toSeconds(execTime) + " s");
        System.out.println("Insert time in the middle of the LinkedList: " + execTimeLinked + " ns");
        System.out.println("Rapport du temps d'execution ArrayList/LinkedList = " + (execTimeArray / execTimeLinked));
    }
}
